> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.tabs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.tabs.com/_mcp/server.

# Upsert obligation custom revenue

POST https://integrators.prod.api.tabsplatform.com/v3/contracts/{id}/obligation/{obligationId}/custom-revenue
Content-Type: application/json

Reference: https://docs.tabs.com/api-reference/contracts/upsertCustomRevenue

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Tabs External API
  version: 1.0.0
paths:
  /v3/contracts/{id}/obligation/{obligationId}/custom-revenue:
    post:
      operationId: integrators-api-contractsv-3-controller-upsert-custom-revenue
      summary: Upsert obligation custom revenue
      tags:
        - contracts
      parameters:
        - name: id
          in: path
          description: Contract id
          required: true
          schema:
            type: string
        - name: obligationId
          in: path
          description: Obligation id
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Upsert custom revenue
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Contracts_IntegratorsApiContractsv3Controller_upsertCustomRevenue_Response_200
        '400':
          description: Bad request body, e.g. invalid timeframe
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Contract or obligation not found
          content:
            application/json:
              schema:
                description: Any type
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              type: array
              items:
                $ref: '#/components/schemas/CustomRevenue'
servers:
  - url: https://integrators.prod.api.tabsplatform.com
    description: https://integrators.prod.api.tabsplatform.com
components:
  schemas:
    CustomRevenue:
      type: object
      properties:
        timeframe:
          type: string
          description: Timeframe
        total:
          type: number
          format: double
          description: Total
      required:
        - timeframe
        - total
      title: CustomRevenue
    Contracts_IntegratorsApiContractsv3Controller_upsertCustomRevenue_Response_200:
      type: object
      properties: {}
      description: Empty response body
      title: >-
        Contracts_IntegratorsApiContractsv3Controller_upsertCustomRevenue_Response_200
  securitySchemes:
    custom-header:
      type: apiKey
      in: header
      name: Authorization

```

## Examples



**Request**

```json
[
  {
    "timeframe": "2024-03",
    "total": 10000
  }
]
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue"

payload = [
    {
        "timeframe": "2024-03",
        "total": 10000
    }
]
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '[{"timeframe":"2024-03","total":10000}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue"

	payload := strings.NewReader("[\n  {\n    \"timeframe\": \"2024-03\",\n    \"total\": 10000\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"timeframe\": \"2024-03\",\n    \"total\": 10000\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"timeframe\": \"2024-03\",\n    \"total\": 10000\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue', [
  'body' => '[
  {
    "timeframe": "2024-03",
    "total": 10000
  }
]',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"timeframe\": \"2024-03\",\n    \"total\": 10000\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "timeframe": "2024-03",
    "total": 10000
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://integrators.prod.api.tabsplatform.com/v3/contracts/id/obligation/obligationId/custom-revenue")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```